;Author - Qu
;Version 1.0 - First public release

#NoEnv
SendMode Input
SetWorkingDir %A_ScriptDir%
SetDefaultMouseSpeed, 0
SetTitleMatchMode, 3

;Find game window(s)
WindowTitle:="eGenesis Client"
While (WindowHandle == "" || WindowHandle == 0)
{
  WinWait, %WindowTitle% ahk_class %WindowTitle%
  WinGet, WindowHandle, List, eGenesis Client ahk_class eGenesis Client
}
If (%WindowHandle% > 1)
{
  MsgBox, Multiple game windows found. Using only the first one.
}
WinGetPos, WinPosX, WinPosY, WindowWidth, WindowHeight, ahk_id %WindowHandle1%

Crematories:=0
Debug:=0

;Define the behavior of crematories here.
;What we're defining here is a sparse three-dimensional array.
;Cx is the crematory number, Bx is the button number (one through five, starting on the left)
;Vx is the bar number. And the value is what that bar does when the button is black.
;1 means the bar goes up when the button is black, -1 means it goes down.

;Crematory at 754, 5708
C1B1V2:=1
C1B2V5:=1
C1B2V6:=1
C1B3V3:=-1
C1B4V4:=-1
C1B4V7:=-1
C1B5V1:=1

;Crematory at 754, 5709
C2B1V5:=-1
C2B2V1:=-1
C2B2V7:=1
C2B3V4:=1
C2B4V2:=1
C2B4V6:=1
C2B5V3:=-1

WinWaitActive, eGenesis Client ahk_class eGenesis Client

CrematoryFilename1:="this_is_a_crematory.png"
;Need the image file
;CrematoryFilename2:="this_is_your_crematory.png"


Loop
{
  If (CrematoryFilename%A_Index% == "")
  {
    break
  }

  SearchStartX1:=0
  SearchStartY1:=0
  CrematoryFilename:=CrematoryFilename%A_Index%
  Loop
  {
    If (SearchStartY1 > WindowHeight - 150)
    {
        break
    }
    ImageSearch, FoundX1, FoundY1, SearchStartX1, SearchStartY1, WindowWidth, WindowHeight - 150, *60 %CrematoryFilename%
    If (ErrorLevel == 2)
    {
      MsgBox, %CrematoryFilename%: File not found or invalid search area.
      return
    }
    If (ErrorLevel == 1)
    {
      break
    }
    If (ErrorLevel == 0)
    {
      Crematories++
      CrematoryX%Crematories%:=FoundX1
      CrematoryY%Crematories%:=FoundY1
      SearchStartY1:=FoundY1 + 1

      ;Now we find all the windows on the same row
      SearchStartX2:=FoundX1 + 1
      SearchStartY2:=FoundY1
      Loop
      {
        If (SearchStartX2 > WindowWidth)
        {
          break
        }
        ImageSearch, FoundX2, FoundY2, SearchStartX2, SearchStartY2, WindowWidth, SearchStartY2 + 25, *60 %CrematoryFilename%
        If (ErrorLevel == 2)
        {
          MsgBox, %CrematoryFilename%: File not found or invalid search area.
          return
        }
        If (ErrorLevel == 1)
        {
          break
        }
        If (ErrorLevel == 0)
        {
          Crematories++
          CrematoryX%Crematories%:=FoundX2
          CrematoryY%Crematories%:=FoundY2
          SearchStartX2:=FoundX2 + 1
        }
      }
    }
  }
}

;Now find the dimensions for each window and other properties
Loop, %Crematories%
{
  i:=A_Index
  ImageSearch, UpperRightX, , CrematoryX%i%, CrematoryY%i%, WindowWidth, CrematoryY%i% + 7, *60 upper_right_8x8.png
  If (ErrorLevel == 2)
  {
    MsgBox, upper_right_8x8.png: File not found or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    MsgBox, Could not locate the upper right corner of crematory %i%.
    return
  }
  If (ErrorLevel == 0)
  {
    CrematoryEndX%i%:=UpperRightX + 8
  }

  ImageSearch, , LowerRightY, CrematoryEndX%i% - 16, CrematoryY%i%, CrematoryEndX%i% - 1, WindowHeight, *60 lower_right_16x16.png
  If (ErrorLevel == 2)
  {
    MsgBox, lower_right_16x16.png: File not found or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    MsgBox, Could not locate the lower right corner of crematory %i%.
    return
  }
  If (ErrorLevel == 0)
  {
    CrematoryEndY%i%:=LowerRightY + 16
  }

  ImageSearch, ControlX, ControlY, CrematoryX%i%, CrematoryY%i%, CrematoryEndX%i%, CrematoryEndY%i%, *60 upper_left_control_8x8.png
  If (ErrorLevel == 2)
  {
    MsgBox, upper_right_control_8x8.png: File not found or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    MsgBox, Could not locate the control window on crematory %i%.
    return
  }
  If (ErrorLevel == 0)
  {
    CrematoryControlX%i%:=ControlX
    CrematoryControlY%i%:=ControlY
  }

  ImageSearch, BarMidX, BarMidY, CrematoryControlX%i%, CrematoryControlY%i%, CrematoryEndX%i%, CrematoryEndY%i%, *60 *TransBlack bars_middle.png
  If (ErrorLevel == 2)
  {
    MsgBox, bars_middle.png: File not found or invalid search parameters.
    return
  }
  If (ErrorLevel == 1)
  {
    MsgBox, Could not locate the bars on crematory %i%.
    return
  }
  If (ErrorLevel == 0)
  {
    CrematoryBarX%i%:=BarMidX + 6
    CrematoryBarY%i%:=BarMidY - 62
    Loop, 5
    {
      Crematory%i%Button%A_Index%X:=CrematoryBarX%i% + 30 + 40*(A_Index - 1)
      Crematory%i%Button%A_Index%Y:=CrematoryBarY%i% + 129 + 11
    }
  }
}

If (Crematories == 0)
{
  MsgBox, No crematory windows found.
}
else
{
  MsgBox, Found %Crematories% crematory window(s). Ready to start.
}

;Begin Hotkeys
Hotkey, IfWinActive, eGenesis Client ahk_class eGenesis Client

;Main control macro
^!a::
Loop
{
  Loop, %Crematories%
  {
    i:=A_Index
    ImageSearch, ProgressBarX, , CrematoryControlX%i%, CrematoryControlY%i% - 10, CrematoryEndX%i%, CrematoryEndY%i%, *60 progress_bar_end.png
    If (ErrorLevel != 0 || CrematoryProgressBar%i% == ProgressBarX)
    {
      continue
    }

    If (Debug == 1)
    {
      Temp:=CrematoryProgressBar%i%
      FileAppend, Tick: %A_TickCount%`, OldBarX: %Temp%`, NewBarX: %ProgressBarX%`n, DebugLog.txt
    }

    CrematoryProgressBar%i%:=ProgressBarX
    Crematory%i%IsIdle:=0

    ;Here we get the state of bars
    Loop, 7
    {
      j:=A_Index - 1
      ImageSearch, , BarY, CrematoryBarX%i% + j*36, CrematoryBarY%i% - 8, CrematoryBarX%i% + j*36 + 3, CrematoryBarY%i% + 131, *10 black_4x4.png
      If (ErrorLevel == 0)
      {
        Crematory%i%Bar%A_Index%:=CrematoryBarY%i% + 61 - BarY
        If (Debug == 1)
        {
          Temp:=Crematory%i%Bar%A_Index%
          FileAppend, Crematory: %i%`, Bar: %A_Index%: %Temp%`n, DebugLog.txt
        }
      }
    }

    ;Here we get the button states
    Loop, 5
    {
      j:=A_Index - 1
      ImageSearch, , , Crematory%i%Button%A_Index%X - 5, Crematory%i%Button%A_Index%Y - 5, Crematory%i%Button%A_Index%X + 5, Crematory%i%Button%A_Index%Y + 5, *10 black_11x11.png
      If (ErrorLevel == 0)
      {
        Crematory%i%Button%A_Index%:=1
      }
      else
      {
        Crematory%i%Button%A_Index%:=0
      }
      If (Debug == 1)
      {
        Temp:=Crematory%i%Button%A_Index%X
        State:=Crematory%i%Button%A_Index%
        FileAppend, Crematory: %i%`, Button: %A_Index%: %Temp%`, State: %State%`n, DebugLog.txt
      }
    }

    ;We got the bar and button states of the crematory. Now time for the logic part.
    ;Yes this works by magic.
    Loop, 5
    {
      j:=A_Index
      Sum:=0
      Loop, 7
      {
        k:=A_Index
        Sum-=(Crematory%i%Bar%k% == "" ? 0 : Crematory%i%Bar%k%)*C%i%B%j%V%k%
      }
      If (Sum != 0 && (Sum > 0)^Crematory%i%Button%j%)
      {
        KeyWait, LButton
        KeyWait, RButton
        MouseGetPos, MouseX, MouseY
        MouseClick, Left, Crematory%i%Button%j%X, Crematory%i%Button%j%Y
        MouseMove, MouseX, MouseY
      }
      If (Debug == 1)
        FileAppend, Button: %j%`, Sum: %Sum%`n, DebugLog.txt
    }
  }
}
return

Hotkey, IfWinActive
;Script hotkeys

^!+`::Pause
^!+r::Reload
^!+e::Edit